︠677cfcb8-52f5-4f48-8507-bea3a09514fe︠
# Problem set 2
︡75057974-ac35-4dee-8d35-76d3995eb3cb︡
︠2c23bccb-208f-4372-b750-06a5c783d579︠

reset
︡4cf70112-f6e3-405e-b41d-5a29617332cf︡{"stdout":"<function reset at 0x7fc4d86bb050>"}︡{"stdout":"\n"}︡{"done":true}
︠307ce6c4-01db-4021-8fa2-a86cd0a2ea0fs︠

#Exercise 1 (demo): Goldbach conjecture
def my_goldbach(n): #n must be even
    L=prime_range(n/2)
    S=[]
    for c in L:
        if is_prime(n-c):
            S.append([c,n-c])
    return S
my_goldbach(24)
︡25e68d4d-efac-444a-8794-698d31c564c0︡{"stdout":"[[5, 19], [7, 17], [11, 13]]\n"}︡{"done":true}
︠a68238b3-833f-44fe-9ba6-234db0ec7b20s︠
#Exercise 2(a): Eratosthenes algorithm (template)
reset()
#Simple code snippet
#Input: list of integers L and an integer m
# Output: list L with multiples of m removed
def remove_multiple(m,L):
    for c in L:
        if (c % m)==0:
            L.remove(c)
    return L
#Example
L=[2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20];
remove_multiple(2,L)
︡afe43c2e-2d3f-4373-852a-68d45b0ea65a︡{"stdout":"[3, 5, 7, 9, 11, 13, 15, 17, 19]\n"}︡{"done":true}
︠73f4e5cc-3e9e-4593-beb5-aac447550cf1s︠
remove_multiple(L[0],L)# Think what L[0] is in the input L
︡504c74d6-f236-42e1-bcbb-1899e6a1c682︡{"stdout":"[5, 7, 11, 13, 17, 19]\n"}︡{"done":true}
︠ad5a2a32-4d73-49d8-ba2d-a1f2e60b2eafs︠
#Exercise 2: Eratosthenes algorithm
def simple_erato(n):#Fill in the blanks
    S=[] # S is a placeholder for primes <=k that will be removed
    L=[j for j in range(2,n+1)]# list of numbers <=n with L[0]=2; L will be changing
    k=floor(sqrt(n)) # Fact:for any composite number less or equal n there is a prime factor <=k       #floor=less or equal than
    while L[0]<=k:
        S.append(L[0]) #Save the current prime in this list
        remove_multiple(L[0],L)
    return S+L
simple_erato(50)
︡31721aa1-cb72-4da8-9394-9c65411d5bb9︡{"stdout":"[2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47]\n"}︡{"done":true}
︠969f2c61-460c-4085-a8b1-241c1da0b172s︠
[j for j in range(2,51)] #This is how you make alist of integers <=50
︡4e4ba408-1242-4f77-91ff-52103880c60a︡{"stdout":"[2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50]\n"}︡{"done":true}
︠bee326cf-c1c1-4f2d-a519-95b978798d85s︠
#Alternative template for Eratosthenes algorithm
def fancy_erato(n):
    S=[] # S is a placeholder for primes <k
    L=[j for j in range(2,n+1)]# list of numbers from <=n with L[0]=2; L will be changing
    k=floor(sqrt(n)) # for any composite number less or equal n there is a prime factor <=k
    while L[0]<=k:
        S.append(L[0])
        L=filter(lambda a: a % L[0]!=0, L) # compact form of our function remove_multiple
        # != means "not equal"; when a%L[0]!=0 is False, the element a is filtered (removed)
    S=S+L
    return S
︡58e292f0-f21a-403d-a960-bbe623c7b425︡{"done":true}
︠4fe696e8-3fe3-4e74-98d2-a353b5d42459s︠
fancy_erato(50)
︡ae7eec6f-2676-4c22-a71c-eef367a84f43︡{"stdout":"[2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47]\n"}︡{"done":true}
︠e48aa028-8f64-4892-81ad-9953fe1574a7s︠
#Exercise 3 (template): Fermat's factorization algorithm is based on the following fact:
#Every odd number N is the difference of squares, N=a^2-b^2=(a-b)*(a+b).
def fermat_factors(N): # N should be odd
    a = math.ceil(sqrt(N))# calling math is important. It returns a as decimal number
    b = math.sqrt(a^2-N)
    print(a,b)
    while floor(b)-b!=0:#The condition should verify if b is an integer    #integer: floor(b)-b!=0
        a = a + 1 # Alternative Python-like form of this command: a+=1
        b =math.sqrt(a^2-N)
        print a,b
    print "a =", a
    print "b =", b
    print "c =", a+b
    print "d =", a-b
#Test
fermat_factors(51)
︡07489aa7-4e47-4cf6-a12a-441586a038f3︡{"stdout":"(8.0, 3.605551275463989)\n9.0 5.47722557505\n10.0 7.0\na = 10.0\nb = 7.0\nc = 17.0\nd = 3.0\n"}︡{"done":true}
︠36194984-6ff6-496a-9816-d60035d14cc6s︠
prime_pi(7);Li(7).n()
︡88435350-ad45-4831-bfe6-72fc8bf866c0︡{"stdout":"4\n3.71188798588011"}︡{"stdout":"\n"}︡{"done":true}
︠106369d5-e9ef-4b4c-a302-eca313f6226as︠
#Exercise 4: Counting primes
#Directions
#Sage uses notation prime_pi for Prime Counting Function. Sage also knows function Li.
#Define the function x/log(x). Make plots of the the three functions and store them under names of your choice. Include legend into each plot. Then plot all three plots in one figure using command show.f(x)=1-x; g(x)=x^2-2*x
f(x)=x/log(x)
p=plot(f(x),3,1500,legend_label='f(x)',color='green',thickness=2)
q=plot(prime_pi(x),3,1500,legend_label='pi(x)',color='red',thickness=2)
r=plot(Li(x),3,1500,legend_label='Li(x)',color='blue',thickness=2)
show(p+q+r,figsize=[4,2])
︡b9d70fdf-2474-4599-b072-d1873d0b399e︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/537/tmp_zB__f2.svg","show":true,"text":null,"uuid":"b7e7635f-6dc5-4ea2-a081-9646e0e4cbf0"},"once":false}︡{"done":true}
︠9e1f43a0-6c72-4eab-bea1-549e43a8675fs︠
9/63
︡08698a46-757e-4800-ae91-5b44c879c66c︡{"stdout":"1/7\n"}︡{"done":true}
︠f2d51774-54d3-4604-92db-75c54594dd38s︠
#Exercise 8: Constructing one PPT (template)
#Input: a rational number r, 0<r<1
#Output: legs of the ppt defined by
def one_ppt(r):
    m=numerator(r)
    n=denominator(r)
    if m%2==0 and n%2==0:
        print('both m and n are odd')
    else:
        a=2*m+1;
        b=2*n+1;
        return [a,b,N(sqrt(a^2+b^2))]
one_ppt(2/3)
︡4d15cc2b-6144-45ca-b742-c3deef6faa49︡{"stdout":"[5, 7, 8.60232526704263]"}︡{"stdout":"\n"}︡{"done":true}
︠4c42d4c2-902d-4be7-83a7-70f24bde4dd7︠

-------------------------------------------------------------------------------
#lab 1 solution


#Lab 1: Plotting legs (a,b) of Primitive Pythagorean Triples


#1. The function makes a list of pairs [m,n] of rationals m/n from N diagonals of the table of rationals
#//Input:?
#//Output:?
def mn_pairs(N):
    L=[];
    for n in range(2,N+2):
        temp=[[m,n] for m in range(1,n)]
        L.extend(temp)
    return L

#Example
L=mn_pairs(10);L
︡fbd39dc4-4ff1-4c95-977d-d85103f14bd2︡{"stdout":"[[1, 2], [1, 3], [2, 3], [1, 4], [2, 4], [3, 4], [1, 5], [2, 5], [3, 5], [4, 5], [1, 6], [2, 6], [3, 6], [4, 6], [5, 6], [1, 7], [2, 7], [3, 7], [4, 7], [5, 7], [6, 7], [1, 8], [2, 8], [3, 8], [4, 8], [5, 8], [6, 8], [7, 8], [1, 9], [2, 9], [3, 9], [4, 9], [5, 9], [6, 9], [7, 9], [8, 9], [1, 10], [2, 10], [3, 10], [4, 10], [5, 10], [6, 10], [7, 10], [8, 10], [9, 10], [1, 11], [2, 11], [3, 11], [4, 11], [5, 11], [6, 11], [7, 11], [8, 11], [9, 11], [10, 11]]\n"}︡{"done":true}
︠0edae566-d8e4-4eaa-9ba6-c4e47f78c937s︠
# 2.The function makes a list of legs [a,b] of PTs and excludes PTs that are not primitive (i.e., pairs with a and b are not mutuallly prime)
#//Input:
#//Output:number of PTs in L,number of PPT in L,list of PPTs
def ppt_legs(L):
    p_triples=[[c[1]^2-c[0]^2,2*c[0]*c[1]] for c in L ]#list of PTs
    pp_triples=[t for t in p_triples if gcd(t[0],t[1]) == 1]#list of PPTs
    return(len(p_triples),len(pp_triples),pp_triples)
︡e81f7157-a448-439b-ac6c-5c1a34792c08︡{"done":true}
︠9120db0b-6859-4df7-a9f3-fb0fe02ac09as︠
n_pt,n_ppt,S=ppt_legs(L);n_pt #Convenient way to get multiple output
︡93602bd0-8ca8-4ebe-b263-47356813055d︡{"stdout":"55\n"}︡{"done":true}
︠31ed0917-ec92-4584-aa15-65604ccfd3b5s︠
n_ppt
︡751f4b8b-eb22-4f52-93f0-49d5dd1efa53︡{"stdout":"27\n"}︡{"done":true}
︠9593765d-aa1e-40fa-9cd2-4ddf53586e1cs︠
#Example of plotting points in SageMath
point(S,size=30,color='red',figsize=[4,3])
︡0464fe01-ddb6-4a7e-a2c4-d41965146a6a︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/537/tmp_EbqxHD.svg","show":true,"text":null,"uuid":"be8e0017-2ab6-49b4-b1a5-2637ce2aad6b"},"once":false}︡{"done":true}
︠6f64c5cb-19e6-42d7-be6e-d5e3692907eas︠
#3. Main code
#//Input: Number of diagonals in the table of rationals
#//Output:?
def plot_ppt(N):
    L=mn_pairs(N)
    n_pt,n_ppt,S=ppt_legs(L)
    G=point(S,size=30,color='red',figsize=[5,4])
    G.show()
    return("Number of PTs:", n_pt, "Number of PTs:",n_ppt)
︡30548186-9eee-40bd-a7e0-611f5e43807b︡{"done":true}
︠fc9bf5bd-da0c-4f95-9432-3d0f48db8ae6s︠
plot_ppt(20)
︡1a9695e5-fcff-4998-aaca-3052239a6a0e︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/537/tmp_tPEinb.svg","show":true,"text":null,"uuid":"36e37c25-bb58-4fe9-9b27-465ae8d8697d"},"once":false}︡{"stdout":"('Number of PTs:', 210, 'Number of PTs:', 92)"}︡{"stdout":"\n"}︡{"done":true}
︠9185cce7-ad25-4a15-93f8-2c0b645211fas︠
#Example of alternative plotting points in S using Python libraries
# Get data for plotting points
x=[s[0] for s in S];y=[s[1] for s in S]
︡685a129a-de54-4925-bb59-6daaa71518dc︡{"done":true}
︠351115e1-0628-444c-86c1-52e15286b87fs︠
import matplotlib.pyplot as plt
from matplotlib.pyplot import figure
figure(num=None, figsize=(5, 3))
figure=plt.plot(x, y,'ro',markersize=4)
plt.show(figure)
︡e91b1c35-91a6-44ae-bd43-668146d7317d︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/537/tmp_NR_eXo.svg","show":true,"text":null,"uuid":"b6b8d474-58f2-4b49-8dbc-66e5b5c1c4bb"},"once":false}︡{"file":{"filename":"975e080f-4f58-4d42-9641-99c7fc68b5f3.svg","show":true,"text":null,"uuid":"6db854ba-30d4-4f38-b598-1c9ee90e76f5"},"once":false}︡{"done":true}
︠81ebbdcf-57a2-4271-aebd-7d3673ee6e6es︠
#Advanced nice snippet of code for plotting (just FYI)
import numpy as np
import matplotlib.pyplot as plt

#evenly sampled time at 200ms intervals
t = np.arange(0., 5., 0.2)

# red dashes, blue squares and green triangles
plt.plot(t, t, 'r--', t, t**2, 'bs', t, t**3, 'g^')
plt.show()

︡ade71613-6686-40a9-9692-5293f344b6ae︡{"stdout":"[<matplotlib.lines.Line2D object at 0x7f8117accb50>, <matplotlib.lines.Line2D object at 0x7f8117acca90>, <matplotlib.lines.Line2D object at 0x7f8117abb150>]\n"}︡{"file":{"filename":"32a0e7f2-f69e-4b72-8123-a39d8f9abe24.svg","show":true,"text":null,"uuid":"942dc046-0e59-41c5-a72c-00a4d7013db4"},"once":false}︡{"done":true}
︠27f15b2a-4aa6-4a3b-bb61-985c398b2fa5︠
#For instructor_________________________________
#Data for detecting missed points
xblue=[195,187,171,115,75,27];yblue=[28,84,140,252,308,364]
#figure=plt.plot(xblue,yblue,'bo',markersize=4)# Include into the plotting command code above

︡70a8825e-0ce6-4982-a2df-61baedf71749︡
︠c7a948f4-bdbb-48ac-b8d0-ce2654e42492︠
#4 Find the missing point in the figure created in Part 3 (see directions in Chapter 2)
gcd(147,196)
︡d589e3fe-d1fe-40ca-9915-6780c38cd999︡{"stdout":"49\n"}︡{"done":true}









